@echo off
cd /d %~dp0
if not exist "%~dp0ice.exe" (
 echo ERROR:ice.exe was not found!
 pause
 exit /b
) 
if "%~1" == "" (
 echo How to use %~nx0
 echo.
 echo 1 Place the original .ICE file in %~dp0
 echo.
 echo 2 Put the files you want to repack in a folder named same as the
 echo   original.ICE file. This folder can be placed everywhere and
 echo   the name added an underscore will also be accepted.
 echo.
 echo 3 Drag and drop the folder to %~nx0.
 echo   When the files with the same name as the file in the folder
 echo   are exist in the ICE file, those files will be replaced
 echo   while retaining group assignment and CRC.
 pause
 exit /b
)

set foname=
set fopath=
set frmname=
set fname=
set fpath=
set counter=0

set foname=%~n1
set fopath=%~dpn1
set frmname=%foname:_=%
set fpath=%~dp1

if not exist "%~dp0%frmname%" (
 echo ERROR:The ICE file"%frmname%" could not be found.
 echo Be sure to place the original .ICE file in %~dp0
 pause
 exit /b
)

if not exist "%fpath%\original" (
mkdir "%fpath%\original"
) 

cd /d "%fopath%"
for %%f in (*) do (
 set fname=%%~nxf
 call :replace
)
goto :finish

:replace
cd /d %~dp0
if %counter%== 0 (
 ice.exe -m -r "%fopath%\%fname%" "%~dp0%frmname%"
 echo:
 move /y "%~dp0%frmname%" "%fpath%\original" > nul
 ren "%~dp0ice.exe.ice" "ice.exe.ice_"
 set counter=1
 exit /b
)
ice.exe -m -r "%fopath%\%fname%" "%~dp0ice.exe.ice_"
echo:
del /q "%~dp0ice.exe.ice_"
ren "%~dp0ice.exe.ice" "ice.exe.ice_"
set /a counter=%counter%+1
exit /b

:finish
ren "%~dp0ice.exe.ice_" "%frmname%"

if not %errorlevel% == 0 (
echo NOTICE:One or more problems occured.
) 
echo %counter% files were replaced.
echo The new ICE file was exported as %~dp0%frmname%
echo The original .ICE file was moved to %fpath%original
pause
exit /b
