@echo off
cd /d %~dp0
set fname=
set frmname=

if not exist "%~dp0ice.exe" (
 echo ERROR:ice.exe was not found!
 pause
 exit /b
) 

if "%~1" == "" (
 goto :underbar
) 
rem // Set file name in variable and check for the duplicated
set fname=%~n1
set frmname=%fname:_=%
if not exist "%~dp0%frmname%" (
 goto :archive
) 
cd "%~dp0%frmname%" > nul 2>&1
if %errorlevel%==0 (
 cd /d %~dp0
 ren "%~dp0%frmname%" "%frmname%_"
 goto :archive
) 
del /q "%~dp0%frmname%"

:archive
rem // The section quoted from the original
echo:
"%~dp0ice.exe" -a -g 2 -s "%~dp0group1.txt" -o "%~dp0%~n1.ice" %*
echo:
if exist "%~dp0%~n1.ice" (
 ren "%~dp0%~n1.ice" "%frmname%"
) 
exit /b

rem // Process of adding underscores to all folders in the same directory
:underbar
set errsum=0
for /d %%i in (*) do (
 set fname=%%~ni
 call :recognize
) 
if %errsum%==1 (
echo NOTICE: A file/files has ignored due to the duplicated names.
pause
) 
exit /b
:recognize
set frmname=%fname:~-1%
if %frmname%==_ exit /b
if %fname%==src exit /b
if exist "%fname%_" set errsum=1 & exit /b
ren "%~dp0%fname%" "%fname%_"
exit /b